/*
ன⢠ ...
*/

#include "qgames.h"
#include "qginput.h"

/*...*/


void QGamesKeyboard()
{
	if(libKeyboard)
		return;

	libFunKbOldInter = getvect(9);
	setvect(9,libKeyboardInterrupt);
	memset(libBufferKeyboard,0,32);
	libKeyboard = TRUE;
}

void DosKeyboard()
{
	if(!libKeyboard)
		return;
	setvect(9,libFunKbOldInter);
	libKeyboard = FALSE;
}

void interrupt libKeyboardInterrupt(void)
{
	static BYTE KeyCode;
	static BYTE Index,ExIndex;
	static BYTE Byte;

	BIN(0x60,KeyCode);
	Index   = libTabChar[KeyCode & 0x7F];
	ExIndex = Index & 3;
	Byte = libBufferKeyboard[Index >> 3];

	if(KeyCode & 0x80)
		Byte &= ~(1 << ExIndex);
	else
	{
		libBufferChars[libCharsCounter1++ & 0xf] = Index;
		Byte |= 1 << ExIndex;
	}

	libBufferKeyboard[Index >> 3] = Byte;
	BOUT(0x20,0x20);
}

BOOL GetKey(BYTE KeyNum)
{
	if(libBufferKeyboard[KeyNum >> 3] & (1 << (KeyNum & 3)))
		return TRUE;
	return FALSE;
}

BYTE GetChar(BOOL bPause)
{
	if(libCharsCounter1 == libCharsCounter2)
	{
		if(!bPause)
			return 0;
		while(libCharsCounter1 == libCharsCounter2);
	}
	return libBufferChars[libCharsCounter2++ & 0xf];
}

/*...*/

BOOL GetMouseInit()
{
	asm mov ax,0;
	asm int 0x33;
	if(!_AX)
		return FALSE;
	return TRUE;
}

void MouseCursorOn()
{
	asm mov ax,1;
	asm int 0x33;
}

void MouseCursorOff()
{
	asm mov ax,2;
	asm int 0x33;
}

void SetMouseCursor(WORD HotX,WORD HotY,PBYTE pBit)
{
	if(HotX > 16 || HotY > 16)
		return;

	asm mov ax,9;
	asm mov bx,HotX;
	asm mov cx,HotY;
	asm les dx,pBit;
	asm int 0x33;
}

void GetMouseMap(PSTMOUSEMAP pstMMap)
{
	WORD X,Y,Keys;
	asm mov ax,3;
	asm int 0x33;
	asm mov Keys,bx;
	asm mov X,cx;
	asm mov Y,dx;

	if(libDisplayMode == VGA_MODE)
		X = X >> 1;
	else if(libDisplayMode == TEXT_MODE)
	{
		X = X >> 3;
   	Y = Y >> 3;
	}
	pstMMap->PosY = Y;
	pstMMap->PosX = X;
	pstMMap->RightKey = Keys & 2;
	pstMMap->LeftKey  = Keys & 1;

}

void GetMouseMoving(int* MoveX,int* MoveY)
{
	asm mov ax,0xb;
	asm int 0x33;
	asm les di,MoveX;
	asm mov [es:di],cx;
	asm les di,MoveY;
	asm mov [es:di],dx;
}
