/*
⮢ ० DOS'
*/

#include "qgames.h"

void TxtCls( BYTE bColor)
{
	asm mov di,0xb800;
	asm mov es,di;
	asm xor di,di;
	asm mov ah,bColor;
	asm xor al,al;
	asm mov cx,0x2000;
	asm cld;
	asm rep stosw;
}

void TxtBox(BYTE bLeft,BYTE bTop,BYTE bRight,
				BYTE bBottom,BYTE bColor)
{
	WORD wOffset = ((WORD)(bTop) * 80 + (WORD)(bLeft)) << 1;


	asm xor cx,cx;

	asm mov di,0xb800;
	asm mov es,di;
	asm xor al,al;
	asm mov di,wOffset;
	asm mov ah,bColor;
	asm mov bh,bRight;
	asm mov bl,bLeft;
	asm sub bh,bl;
	asm mov dh,bBottom;
	asm mov dl,bTop;
	asm mov bl,dh;
	asm sub bl,dl;


	asm mov dx,160;
	asm add dl,bLeft;
	asm add dl,bLeft;
	asm sub dl,bRight;
	asm sub dl,bRight;

DRAW:
	asm mov cl,bh;
	asm cld;
	asm rep stosw;

	asm dec bl;
	asm add di,dx;

	asm cmp bl,0;
	asm jne DRAW;


}


void TxtSymb(BYTE bPosX,BYTE bPosY,
					BYTE bColor,BYTE bSymbol)
{
	WORD wOffset = ((WORD)(bPosY) * 80 + (WORD)(bPosX)) << 1;

	asm mov di,0xB800;
	asm mov es,di;
	asm mov di,wOffset;
	asm mov ah,bColor;
	asm mov al,bSymbol;
	asm stosw;
}

void TxtVLine(BYTE bPosX,BYTE bPosY,BYTE bLen,
					BYTE bColor,BYTE bSymbol)
{
	WORD wOffset = ((WORD)(bPosY) * 80 + (WORD)(bPosX)) << 1;

	if(!bLen)
		return;

	asm mov al,bSymbol;
	asm mov ah,bColor;
	asm mov di,0xB800;
	asm mov es,di;
	asm mov di,wOffset;
	asm mov cl,bLen;
	asm xor ch,ch;
	asm cld;
DRAWV:
	asm stosw;
	asm add di,158;
	asm loop DRAWV;


}


void TxtHLine(BYTE bPosX,BYTE bPosY,BYTE bLen,
							BYTE bColor,BYTE bSymbol)
{
	WORD wOffset = ((WORD)(bPosY) * 80 + (WORD)(bPosX)) << 1;

	if(!bLen)
		return;

	asm mov al,bSymbol;
	asm mov ah,bColor;
	asm mov di,0xB800;
	asm mov es,di;
	asm mov di,wOffset;
	asm mov cl,bLen;
	asm xor ch,ch;
	asm cld;
	asm rep stosw;
}


void TxtOut( BYTE bPosX,BYTE bPosY,BYTE bColor,PSTR pMess)
{
	WORD wOffset = ((WORD)(bPosY) * 80 + (WORD)(bPosX)) << 1;

	asm push ds;

	asm mov di,0xB800;
	asm mov es,di;
	asm mov di,wOffset;
	asm lds si,pMess;
	asm mov ah,bColor;
	asm cld;
DRAW:
	asm lodsb;
	asm cmp al,0;
	asm je STOP;
	asm stosw;
	asm cmp al,0;
	asm jmp DRAW;

STOP:
	asm pop ds;
}


void TxtBufferOut( BYTE bPosX,BYTE bPosY,BYTE bColor,
						PSTR pMess,BYTE bLen)
{
	WORD wOffset = ((WORD)(bPosY) * 80 + (WORD)(bPosX)) << 1;
	if(!bLen)
		return;


	asm push ds;

	asm mov di,0xB800;
	asm mov es,di;
	asm mov di,wOffset;
	asm lds si,pMess;
	asm mov ah,bColor;
	asm mov cl,bLen;
	asm xor ch,ch;
	asm cld;
DRAW:
	asm lodsb;
	asm stosw;
	asm cmp al,0;
	asm loop DRAW;

	asm pop ds;
}

void TxtStrOut( BYTE bPosX,BYTE bPosY,BYTE bColor,
					PSTR pMess,BYTE bEndSymb)
{
	WORD wOffset = ((WORD)(bPosY) * 80 + (WORD)(bPosX)) << 1;

	asm push ds;

	asm mov di,0xB800;
	asm mov es,di;
	asm mov di,wOffset;
	asm lds si,pMess;
	asm mov ah,bColor;
	asm mov dl,bEndSymb;
	asm cld;
DRAW:
	asm lodsb;
	asm cmp al,dl;
	asm je STOP;
	asm stosw;
	asm cmp al,0;
	asm jmp DRAW;

STOP:
	asm pop ds;
}
