/*
  ...
*/

#include "qgames.h"
#include "qgts.h"

void QGamesTimer(WORD Freq)
{
	WORD RealFreq;
	if(!libTimer)
	{
		libFunTmOldInter = getvect(8);
		setvect(8,libTimerInterrupt);
	}
	if(Freq < 36)
	{
		libTimerFreq = 2;
		Freq = 36;
	}
	else
		libTimerFreq = Freq/18;

	SetTimer(0xFFFF/libTimerFreq);
	libCounter = 0;
	libTimer = TRUE;
	libTimerFunc = FALSE;
	libfnTimer   = NULL;
}

void DosTimer()
{
	if(!libTimer)
		return;

	SetTimer(0xFFFF);
	setvect(8,libFunTmOldInter);
	libTimer = FALSE;
}

void SetTimer(WORD Speed)
{
	outp(0x43,0x36);
	outp(0x40,Speed & 0xFF);
	outp(0x40,(Speed >> 8) & 0xFF);
}

void interrupt libTimerInterrupt()
{
	libCounter++;
	if(!(libCounter % libTimerFreq))
		(*libFunTmOldInter)();

	if(!libTimerFunc && libfnTimer != NULL)
	{
		libTimerFunc = TRUE;
		libfnTimer();
		libTimerFunc = FALSE;
	}
	BOUT(0x20,0x20);
}
void SetTimerFunc(FNTIMER fnTimer)
{
	libfnTimer = fnTimer;
	libTimerFunc = FALSE;
}

WORD GetTimerCounter()
{
	return libCounter;
}

void libSetSBRegister(WORD Addr,BYTE NumReg,BYTE ByteReg)
{
	asm mov dx,Addr;
	asm mov al,NumReg;
	asm out dx,al;
	asm mov cx,6;
READ_6:
	asm in al,dx;
	asm loop READ_6;
	asm inc dx;
	asm mov dx,Addr;
	asm inc dx;
	asm mov al,ByteReg;
	asm mov ah,0;
	asm out dx,al;
	asm dec dx;
	asm mov cx,35;
READ_35:
	asm in al,dx;
	asm loop READ_35;
}

BYTE libGetSBStat(WORD Addr)
{
	BYTE RetVal;
	asm mov dx,Addr;
	asm in al,dx;
	asm mov RetVal,al;
	return RetVal;
}

void ResetSBlaster(WORD wNum)
{
	BYTE bCounter;
	for(bCounter = 0x1;bCounter < 0xF5;bCounter++)
		libSetSBRegister(wNum,bCounter,0);
}

BOOL GetSBlaster(WORD wNum)
{
	BYTE Result1,Result2;
	libSetSBRegister(wNum,0x4,0x60);
	libSetSBRegister(wNum,0x4,0x80);
	Result1 = libGetSBStat(wNum);
	libSetSBRegister(wNum,0x2,0xFF);
	libSetSBRegister(wNum,0x4,0x21);
	delay(1);
	Result2 = libGetSBStat(wNum);
	if(!(Result1 & 0xE0) && ((Result2 & 0xE0) == 0xC0))
		return TRUE;

	return FALSE;
}

void InitSBlaster(WORD wNum)
{
	BYTE bCounter;
	for(bCounter = 0;bCounter < 9;bCounter++)
	{
		libSetSBRegister(wNum,libAddrChannels1[bCounter] + 0x20,0x01);
		libSetSBRegister(wNum,libAddrChannels1[bCounter] + 0x40,0x10);
		libSetSBRegister(wNum,libAddrChannels1[bCounter] + 0x60,0xF0);
		libSetSBRegister(wNum,libAddrChannels1[bCounter] + 0x80,0x77);
		libSetSBRegister(wNum,libAddrChannels1[bCounter] + 0xA0,0x98);
		libSetSBRegister(wNum,libAddrChannels2[bCounter] + 0x20,0x01);
		libSetSBRegister(wNum,libAddrChannels2[bCounter] + 0x40,0x00);
		libSetSBRegister(wNum,libAddrChannels2[bCounter] + 0x60,0xF0);
		libSetSBRegister(wNum,libAddrChannels2[bCounter] + 0x80,0x77);
	}
}

void SB_SetSR(WORD wNum,BYTE bChannel,BYTE bSust,BYTE bRelease)
{
	BYTE bInpVal = ((bSust & 0xF) << 4) + (bRelease & 15);
	libSetSBRegister(wNum,0x80 + libAddrChannels1[bChannel],bInpVal);
}

void SB_SetAD(WORD wNum,BYTE bChannel,BYTE bAttack,BYTE bDecay)
{
	BYTE bInpVal = ((bAttack & 0xF) << 4) + (bDecay & 15);
	libSetSBRegister(wNum,0x60 + libAddrChannels1[bChannel],bInpVal);
}

void SB_SetVolume(WORD wNum,BYTE bChannel,BYTE bVolume)
{
	libSetSBRegister(wNum,0x40 + libAddrChannels1[bChannel],
									bVolume & 0x3F);
}

void SB_SetVoice(WORD wNum,BYTE bChannel,BYTE bVoice)
{
	libSetSBRegister(wNum,0x20 + libAddrChannels1[bChannel],bVoice & 7);
}

void SB_NoteOn(WORD wNum,BYTE bChannel,BYTE Octave,WORD Note)
{
	BYTE Reg1 = (BYTE)(Note);
	BYTE Reg2 = (BYTE)((Note >> 8) & 3) + ((Octave & 7) << 2) + 0x20;

	libSetSBRegister(wNum,0xA0 + libAddrChannels1[bChannel],Reg1);
	libSetSBRegister(wNum,0xB0 + libAddrChannels1[bChannel],Reg2);

}

void SB_NoteOff(WORD wNum,BYTE bChannel)
{
	libSetSBRegister(wNum,0xB0 + libAddrChannels1[bChannel],0x11);
}

void SB_AllNoteOff(WORD wNum)
{
	BYTE bChannel;
	for(bChannel = 0;bChannel < 9;bChannel++)
		libSetSBRegister(wNum,0xB0 + libAddrChannels1[bChannel],0x11);

}