/*
樠  ࠡ  ஬ VGA...
*/
#include "qgvga.h"
#include <stdlib.h>

void SetDisplayMode(BYTE Mode)
{
	libDisplayMode = Mode;
	switch(Mode)
	{
	case TEXT_MODE:
		asm mov ax,3;
		asm int 0x10;
		return;
	case VGA_MODE:
		asm mov ax,0x13
		asm int 0x10;
		return;
	default:
		return;
	}
}

void SetDisplayPal(PRGBPAL pRgbPal)
{
	WORD Amount;

	switch(libDisplayMode)
	{
	case TEXT_MODE:
		Amount = 48;
		break;
	case VGA_MODE:
		Amount = 768;
		break;
	default:
		return;
	}

	WaitDisplayVrt();

	BOUT(0x3C8,0);

	asm mov cx,Amount;
	asm mov dx,0x3C9;
	asm les di,pRgbPal;
NEXTPAL:
	asm mov al,[es:di];
	asm shr al,2;
	asm out dx,al;
	asm inc di;
	asm loop NEXTPAL;
}

void WaitDisplayVrt(void)
{
	register BYTE Value;
	do
	{
		BIN(0x3DA,Value);
	}while(!(Value & 8));
}

BOOL GetDisplayVrt(void)
{
	register BYTE Value;
	BIN(0x3DA,Value);
	return Value & 8;
}

void CopyVirToScr_WDV(void)
{
	register BYTE Value;
	do
	{
		BIN(0x3DA,Value);
	}while(!(Value & 8));

	asm push ds;
	asm lds si,libVirScreen;
	asm mov di,0xA000;
	asm mov es,di;
	asm xor di,di;
	asm mov cx,32000;
	asm cld;
	asm rep movsw;
	asm pop ds;
}

void CopyVirToScr(void)
{
	asm push ds;
	asm lds si,libVirScreen;
	asm mov di,0xA000;
	asm mov es,di;
	asm xor di,di;
	asm mov cx,32000;
	asm cld;
	asm rep movsw;
	asm pop ds;
}

void ClearScreen(BYTE bColor)
{
	asm mov al,bColor;
	asm les di,libVirScreen;
	asm mov ah,al;
	asm mov cx,32000;
	asm cld;
	asm rep stosw;
}

void SetVirScreen(PSTR pBuffer)
{
	libVirScreen = pBuffer;
}


void SetStdPal(PRGBPAL pRgb,WORD Options,
		WORD ParamA,WORD ParamB,WORD ParamC)
{
	register WORD wCounter;
	switch(Options)
	{
	case MONO_PAL:
		for(wCounter = 0;wCounter < 256;wCounter++)
		{
			pRgb[wCounter].Red   = wCounter;
			pRgb[wCounter].Green = wCounter;
			pRgb[wCounter].Blue  = wCounter;
		}
		return;
	case RGB_PAL:
		for(wCounter = 0;wCounter < 256;wCounter++)
		{

			pRgb[wCounter].Red =
				(((wCounter & 0x30) >> 4) + ((wCounter & 0xC0) >> 6) ) * ParamA;
			pRgb[wCounter].Green =
				(((wCounter & 0x0C) >> 2) + ((wCounter & 0xC0) >> 6) ) * ParamB;
			pRgb[wCounter].Blue =
				(((wCounter & 0x03)) + ((wCounter & 0xC0) >> 6) ) * ParamC;
		}
		return;
	}

}

void InitPalTable(PSTR pTable)
{
	asm les di,pTable
	asm mov bx,0xff

LOOP_1:
	asm mov es:[bx + di],bl
	asm dec bx
	asm jnz LOOP_1

	asm mov es:[bx + di],bl
}

void ConvertBitmap(PBITMAP pBmp,PSTR pTable)
{
	asm push ds
	asm push bp
	asm les si,pBmp
	asm lds bx,pTable
	asm mov ax,es:[si]
	asm mul word ptr es:[si+2]
	asm mov di,ax
	asm les bp,es:[si+4]

LOOP_2:
	asm mov al,[es:bp + di]
	asm xlat
	asm mov [es:bp + di],al
	asm dec di
	asm jnz LOOP_2

	asm mov al,[es:bp + di]
	asm xlat
	asm mov [es:bp + di],al

	asm pop bp
	asm pop ds
}

void PalTable(PRGBPAL pSrc,PRGBPAL pDst,PSTR pTable,
					WORD wMin,WORD wMax)
{
	static long lRealColor;
	static long lRealRed,lRealGreen,lRealBlue;
	static long lMinColor;
	register WORD wCounter1,wCounter2;

	for(wCounter1 = 0;wCounter1 < 256;wCounter1++)
	{
		lMinColor = 0xFFFFFF;
		for(wCounter2 = wMin;wCounter2 < wMax;wCounter2++)
		{
			lRealRed =
				((long)(pSrc[wCounter1].Red) - (long)(pDst[wCounter2].Red)) *
					((long)(pSrc[wCounter1].Red) - (long)(pDst[wCounter2].Red));
			lRealGreen =
				((long)(pSrc[wCounter1].Green) - (long)(pDst[wCounter2].Green)) *
					((long)(pSrc[wCounter1].Green) - (long)(pDst[wCounter2].Green));
			lRealBlue =
				((long)(pSrc[wCounter1].Blue) - (long)(pDst[wCounter2].Blue)) *
					((long)(pSrc[wCounter1].Blue) - (long)(pDst[wCounter2].Blue));
			lRealColor = lRealBlue + lRealRed + lRealGreen;
			if(lRealColor < lMinColor)
			{
				lMinColor = lRealColor;
				pTable[wCounter1] = (BYTE)wCounter2;

			}
		}
	}
}

BYTE GetPalColor(BYTE bRed,BYTE bGreen,BYTE bBlue,PRGBPAL pPal)
{
	register WORD wCounter;
	register BYTE ReturnValue;
	static long lRealColor;
	static long lRealRed,lRealGreen,lRealBlue;
	static long lMinColor;

	lMinColor = 0xFFFFFF;
	for(wCounter = 0;wCounter < 255;wCounter++)
	{
		lRealRed =
			((long)(pPal[wCounter].Red) - (long)(bRed)) *
				((long)(pPal[wCounter].Red) - (long)(bRed));
		lRealGreen =
			((long)(pPal[wCounter].Green) - (long)(bGreen)) *
				((long)(pPal[wCounter].Green) - (long)(bGreen));
		lRealBlue =
			((long)(pPal[wCounter].Blue) - (long)(bBlue)) *
				((long)(pPal[wCounter].Blue) - (long)(bBlue));
		lRealColor = lRealBlue + lRealRed + lRealGreen;
		if(lRealColor < lMinColor)
		{
			lMinColor   = lRealColor;
			ReturnValue = wCounter;
		}
	}
	return ReturnValue;
}